//+------------------------------------------------------------------+
//|                                          TMS Angleator v2.00.mq4 |
//|                                                     Griffin Soul |
//|                         http://www.forexfactory.com/griffinssoul |
//+------------------------------------------------------------------+
#property copyright "Griffin Soul"
#property link      "http://www.forexfactory.com/griffinssoul"
#property version   "2.00"
#property strict
#property indicator_chart_window

/*
Important: the TMS Angleator has been designed around the first TDI indi (the one submitted by Big E) 
found on the TMS thread. I find that in order to refresh things you must toggle/dial through each TF (1H,4H,D1). 
This is no problem if making trading decisions based on candle Close as per rules.

Panel_Ratio: The panel ratio can be used to standardised your panel window : i usually have mine set to around 7.00

TDI_Rel_Angle: The TDI_Rel_Angle is just the ratio the Green and Red instantaneous angles: larger values 
usually represent better crosses while values around minus 1 means the cross is happening like a road 
intersection - a square crossing. If the value is plus one then a cross is not happening.

TDI_Separation: I use the separation of the Green and Red TDI lines as an indication of a cross (either in 
progress or otherwise) and a measure of PA strength. I find values of greater than 5.00 generally denotes fast 
and strong PA.  

The arrows are colored Green, Black: or Red: Green if the instantaneous angle of the Green TDI line is b/w 30 to 
90 degrees, Black if its b/w 30 to -30 degrees or Red if its b/w -30 and -90 degrees. If a Green arrow is b/w 30 
and 60 degrees (1 to 2 O'Clock) it is a good strength signal and the arrow font will be represented by a diagonal 
pointing Green arrow while an angle of 60 to 90 degrees (12 to 1 O'Clock) will represent a strong signal by a 
upward pointing Green arrow. (The total opposite for the Red arrow applies.) A Black arrow (2 to 4 O'Clock) 
represents a weak signal.

TDI_signal: the trade signal requires the cross to be at least of good strength with support on the HTF. For example 
for a 1H/4H signal, there should be a cross on the 1H with support on the 4H by at least a good strength angle. In
addition the previous candle range (H-C) should be greater than 10pips for 1H or 30pips for 4H. Also, the TDI_Separation 
should be crossing - less than 1.00 (default)
*/ 

// External settings

extern color Text_Color = clrLightGray;
extern color Back_Ground_Color = clrBlack;
extern string Font_Type = "Calibri";
extern int Font_Size = 8;
extern int Expand_X = 0;
extern double TDI_cross_threshold = 1.00; // TDI cross happens within Green/Red line separation less than 1.00 (default)
extern double TDI_normal_threshold = 5.00; // Separation is normal for values less than 5.00 (default) & strong > 5.00
extern int Range_1H_pips = 10.00;
extern int Range_4H_pips = 30.00;

// Global declarations   

double GreenAngle;
double RedAngle;
double ratio;
double GreenAngle_HX;
double RedAngle_HX;
double test_TdiDistance;
double convert2pips;
string ratio_display;
string Tdi_signal_buysell;
string Tdi_cross_H1;
string Tdi_cross_H4;
string Tdi_cross_D1;
string degree_display;
string TdiDistance;
string Tdi_cross_HX;
color wing_color_HX;


   
//---
// Start 
//---
int start()
{
      
//---Panel Ratio
Panel_Ratio();

   ObjectCreate("panel_height", OBJ_LABEL,1, 0, 0);
      ObjectSet("panel_height", OBJPROP_CORNER, 1);
      ObjectSet("panel_height", OBJPROP_XDISTANCE, 10);
      ObjectSet("panel_height", OBJPROP_YDISTANCE, 10); 
   ObjectSetText("panel_height",  "Panel Ratio: " +ratio_display, Font_Size, Font_Type, Text_Color);      
      
//---Angles    
Current_Angles();  
   ObjectCreate("TDIAngle", OBJ_LABEL, 1, 0, 0);
      ObjectSet("TDIAngle", OBJPROP_CORNER, 1);
      ObjectSet("TDIAngle", OBJPROP_XDISTANCE, 10);
      ObjectSet("TDIAngle", OBJPROP_YDISTANCE, 25);
   ObjectSetText("TDIAngle", "TDI Rel Angle: " +degree_display + " Green: " +GreenAngle + " Red: " +RedAngle , Font_Size, Font_Type, Text_Color);
    
//---Separation   
Seperation();
   ObjectCreate("tdi_angle", OBJ_LABEL,1, 0, 0);
      ObjectSet("tdi_angle", OBJPROP_CORNER, 1);
      ObjectSet("tdi_angle", OBJPROP_XDISTANCE, 10);
      ObjectSet("tdi_angle", OBJPROP_YDISTANCE, 40);          
   ObjectSetText("tdi_angle",  "TDI Separation: " +TdiDistance, Font_Size, Font_Type, Text_Color);   
   
//---(1H,4H,D1) Arrow Directions  
//---H1 
Arrow_Directions(PERIOD_H1); 

ObjectCreate("honesign",OBJ_LABEL,1,0,0);
   ObjectSet("honesign",OBJPROP_CORNER,1);
   ObjectSet("honesign",OBJPROP_XDISTANCE,140);
   ObjectSet("honesign",OBJPROP_YDISTANCE,100); 
ObjectSetText("honesign","H1",Font_Size,Font_Type,Text_Color);      

ObjectCreate("onesign",OBJ_LABEL,1,0,0);
   ObjectSet("onesign",OBJPROP_CORNER,1);
   ObjectSet("onesign",OBJPROP_BACK,false);
   ObjectSet("onesign",OBJPROP_XDISTANCE,140);
   ObjectSet("onesign",OBJPROP_YDISTANCE,120); 
ObjectSetText("onesign", Tdi_cross_HX, 12,"Wingdings", wing_color_HX);  

//---H4
Arrow_Directions(PERIOD_H4);    

ObjectCreate("hfoursign",OBJ_LABEL,1,0,0);
   ObjectSet("hfoursign",OBJPROP_CORNER,1);
   ObjectSet("hfoursign",OBJPROP_XDISTANCE,90);
   ObjectSet("hfoursign",OBJPROP_YDISTANCE,100); 
ObjectSetText("hfoursign","H4",Font_Size,Font_Type,Text_Color);      

ObjectCreate("secondhfour",OBJ_LABEL,1,0,0);
   ObjectSet("secondhfour",OBJPROP_CORNER,1);
   ObjectSet("secondhfour",OBJPROP_BACK,false);
   ObjectSet("secondhfour",OBJPROP_XDISTANCE,90);
   ObjectSet("secondhfour",OBJPROP_YDISTANCE,120); 
ObjectSetText("secondhfour", Tdi_cross_HX, 12,"Wingdings", wing_color_HX);  

//---D1
Arrow_Directions(PERIOD_D1);  

ObjectCreate("dailysign",OBJ_LABEL,1,0,0);
   ObjectSet("dailysign",OBJPROP_CORNER,1);
   ObjectSet("dailysign",OBJPROP_XDISTANCE,40);
   ObjectSet("dailysign",OBJPROP_YDISTANCE,100); 
ObjectSetText("dailysign","D1",Font_Size,Font_Type,Text_Color);      

ObjectCreate("dailyfour",OBJ_LABEL,1,0,0);
   ObjectSet("dailyfour",OBJPROP_CORNER,1);
   ObjectSet("dailyfour",OBJPROP_BACK,false);
   ObjectSet("dailyfour",OBJPROP_XDISTANCE,40);
   ObjectSet("dailyfour",OBJPROP_YDISTANCE,120); 
ObjectSetText("dailyfour", Tdi_cross_HX, 12,"Wingdings", wing_color_HX);  
 
//---Symbol() Trade Signal   
// Calculate for ECN / Non-ECN brokers 
      if (Digits == 5 || Digits == 3){    
      convert2pips    = Point*10 ; 
      } 
      else if (Digits == 4 || Digits == 2)
      {    
      convert2pips    = Point;     
      } 
      
Trade_Signal(convert2pips);

   ObjectCreate("Signal",OBJ_LABEL,1,0,0);
      ObjectSet("Signal",OBJPROP_CORNER,1);
      ObjectSet("Signal",OBJPROP_XDISTANCE,40);
      ObjectSet("Signal",OBJPROP_YDISTANCE,70); 
   ObjectSetText("Signal","TDI Signal: "+Tdi_signal_buysell,Font_Size,Font_Type,Text_Color);    

//---
return(0);
}


//--
// Functions
//--
void Panel_Ratio(){  
         double height = ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,1);
         double width = ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,1);
          ratio = NormalizeDouble(width / height, 2);
          ratio_display = DoubleToStr(ratio, 2);
}

void Current_Angles(){  
         double TdiGreen0 = iCustom(Symbol(), 0, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  4, 0);
         double TdiGreen1 = iCustom(Symbol(), 0, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  4, 1);
         double TdiRed0 = iCustom(Symbol(), 0, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  5, 0);
         double TdiRed1 = iCustom(Symbol(), 0, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  5, 1);
         double TdiGreenDegrees = (MathArctan(TdiGreen0 - TdiGreen1)*180)/3.1415;
         double TdiRedDegrees = (MathArctan(TdiRed0 - TdiRed1)*180)/3.1415;
         double TdiDegree = TdiGreenDegrees/TdiRedDegrees ;      
         double display_degree = NormalizeDouble(TdiDegree, 2);
          degree_display = DoubleToStr(display_degree, 2);
          GreenAngle = NormalizeDouble(TdiGreenDegrees,0);  
          RedAngle = NormalizeDouble(TdiRedDegrees,0); 
}

void Seperation(){
         double TdiGreen0 = iCustom(Symbol(), 0, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  4, 0);
         double TdiRed0 = iCustom(Symbol(), 0, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  5, 0);
          test_TdiDistance = NormalizeDouble(MathAbs(TdiGreen0 - TdiRed0),2);
         //Alert(test_TdiDistance);
         if(test_TdiDistance < TDI_cross_threshold){
            TdiDistance = "Crossing";
            }
         else if(test_TdiDistance > TDI_cross_threshold && test_TdiDistance < TDI_normal_threshold){
            TdiDistance = "Normal";
            }
         else if(test_TdiDistance > TDI_normal_threshold ){
            TdiDistance = "Strong";
            }
}

void Arrow_Directions(string period_HX){
double TdiGreen0_HX = iCustom(Symbol(), period_HX, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  4, 0);
double TdiGreen1_HX = iCustom(Symbol(), period_HX, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  4, 1);
double TdiRed0_HX = iCustom(Symbol(), period_HX, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  5, 0);
double TdiRed1_HX = iCustom(Symbol(), period_HX, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  5, 1);
double TdiGreenDegrees_HX = (MathArctan(TdiGreen0_HX - TdiGreen1_HX)*180)/3.1415;
double TdiRedDegrees_HX = (MathArctan(TdiRed0_HX - TdiRed1_HX)*180)/3.1415;
 GreenAngle_HX = NormalizeDouble(TdiGreenDegrees_HX,0);  
 RedAngle_HX = NormalizeDouble(TdiRedDegrees_HX,0);        
if(GreenAngle_HX > 60.0){
 Tdi_cross_HX = CharToStr(233); 
 wing_color_HX = clrGreen;
}
else if(GreenAngle_HX > 30.0 && GreenAngle_HX <= 60.0){
 Tdi_cross_HX = CharToStr(236); 
 wing_color_HX = clrGreen;
}
else if(GreenAngle_HX < -60.0){
 Tdi_cross_HX = CharToStr(234);
 wing_color_HX = clrRed;
} 
else if(GreenAngle_HX < -30.0 && GreenAngle_HX >= -60.0){
 Tdi_cross_HX = CharToStr(238);
 wing_color_HX = clrRed;
} 
else{
 Tdi_cross_HX = CharToStr(232);
 wing_color_HX = clrYellow;
}
}

void Trade_Signal(double convert2pips){
double Range_1H = convert2pips * Range_1H_pips;
double Range_4H = convert2pips * Range_4H_pips;
double CRange_H1 = MathAbs(iHigh(Symbol(),PERIOD_H1,1) - iLow(Symbol(),PERIOD_H1,1));
double CRange_H4 = MathAbs(iHigh(Symbol(),PERIOD_H4,1) - iLow(Symbol(),PERIOD_H4,1));
Arrow_Directions(PERIOD_H1);double GreenAngle_H1 = GreenAngle_HX;double RedAngle_H1 = RedAngle_HX;
Arrow_Directions(PERIOD_H4);double GreenAngle_H4 = GreenAngle_HX;double RedAngle_H4 = RedAngle_HX;
Arrow_Directions(PERIOD_D1);double GreenAngle_D1 = GreenAngle_HX;double RedAngle_D1 = RedAngle_HX;
Seperation();
if(GreenAngle_H1 < -30.0 && GreenAngle_H4 < -30.0 && CRange_H1 > Range_1H && test_TdiDistance < TDI_cross_threshold){
Tdi_signal_buysell = "Possible Sell H1/H4"; 
}
else if(GreenAngle_H4 < -30.0 && GreenAngle_D1 < -30.0 && CRange_H4 > Range_4H && test_TdiDistance < TDI_cross_threshold){
Tdi_signal_buysell = "Possible Sell H4/D1";
} 
else if(GreenAngle_H1 > 30.0 && GreenAngle_H4 > 30.0 && CRange_H1 > Range_1H && test_TdiDistance < TDI_cross_threshold){
Tdi_signal_buysell = "Possible Buy H1/H4";
} 
else if(GreenAngle_H4 > 30.0 && GreenAngle_D1 > 30.0 && CRange_H4 > Range_4H && test_TdiDistance < TDI_cross_threshold){
Tdi_signal_buysell = "Possible Buy H4/D1";
} 
else{
Tdi_signal_buysell = "No Signal";
}
}
 
//---


//--
// Setup main background box 
//---
int init()
{
ObjectCreate(0,"box",OBJ_RECTANGLE_LABEL,1,0,0,0);
   ObjectSet("box", OBJPROP_CORNER, 1);
   ObjectSetInteger(0,"box",OBJPROP_BGCOLOR, Back_Ground_Color);
   ObjectSetInteger(0,"box",OBJPROP_XDISTANCE, Expand_X+2);
   ObjectSetInteger(0,"box",OBJPROP_YDISTANCE, 2);
   ObjectSetInteger(0,"box",OBJPROP_XSIZE, Expand_X);
   ObjectSetInteger(0,"box",OBJPROP_YSIZE, 150);
//---  
return(0);
}

//--
// Deinit everything
//---  
int deinit()
{
   ObjectDelete("TDIAngle");
   ObjectDelete("tdi_angle");
   ObjectDelete("box");
   ObjectDelete("panel_height");
   ObjectDelete("Signal");
   ObjectDelete("honesign");
   ObjectDelete("hfoursign");
   ObjectDelete("onesign");
   ObjectDelete("secondhfour");
   ObjectDelete("dailyfour");
   ObjectDelete("dailysign");
//---
return(0);
}

